# -*- coding: utf-8 -*-
"""
Created on Mon Feb 22 10:22:10 2021


"""

Te_0   = 310# current temperature
Ta_0 = Te_0# Initial Ta temperature
dt  = 1#('Give time step size: ')
N_t = 700#('Give number of steps: ')
tau_a = 10
from numpy import linspace, zeros#, exp
t = linspace(0, N_t*dt, N_t+1)
Ta = zeros(N_t+1)
Te = zeros(N_t)

Ta[0] = Ta_0
Te[0] = Te_0
for n in range(0,N_t):
     if n <= 100:            #VEAS 2016-2017 start
        Te[n]= Te_0
     elif 100 < n <= 118:
        Te[n]= 309.5
     elif 118 < n <= 122:
         Te[n]= 308
     elif 122 < n <= 123:
         Te[n] = 315.9
     elif 123 < n <= 124:
         Te[n] = 321.15
     elif 124 < n <= 125:
         Te[n] = 328.3
     elif 125 < n <= 511:
         Te[n] = 328.7
     elif 511 < n <= 512:
        Te[n] = 328
     elif 512 < n <= 518:
         Te[n] = 327
     elif 518 < n <= 519:
         Te[n] = 326.6
     elif 519 < n <= 580:
         Te[n] = 325.1
     elif 580 < n <= 582:
         Te[n] = 324
     elif 582 < n <= 585:
         Te[n] = 323
     elif 585 < n <= 588:
         Te[n] = 322
     elif 588 < n <= 591:
         Te[n] = 321
     elif 591 < n <= 593:
         Te[n] = 320
     elif 593 < n <= 596:
         Te[n] = 319
     elif 596 < n <= 597:
         Te[n] = 318
     elif 597 < n <= 599:
         Te[n] = 316
     elif 599 < n <= 601:
         Te[n] = 315
     elif 601 < n <= 606:
         Te[n] = 313
     elif 606 < n <= 616:
         Te[n] = 312
     elif 616 < n <= 621:
         Te[n] = 311
     else:
         Te[n] = Te_0       #VEAS 2016-2017 end
        
     Ta[n+1] = Ta[n] + dt*(Te[n] - Ta[n])/tau_a

import matplotlib.pyplot as plt
#numerical_sol = 'bo' if N_t < 70 else 'b-'
plt.plot(t, Ta, Te, 'r-' )#, N_0*exp(r*t), 'r-')numerical_sol, t
plt.legend(['T_a', 'T_e'], loc='upper left')#, 'exact'
plt.xlabel('t'); plt.ylabel('T(t)')
#filestem = 'growth1_%dsteps' % N_t
#plt.savefig('%s.png' % filestem); plt.savefig('%s.pdf' % filestem)

# Write out x, y and z to a three-column file, part wher calculated T_a temperature values are printed to a temorary list file: tmp_out_T_a.dat
filename = 'tmp_out_T_a.dat'
outfile = open(filename, 'w')  # Open file for writing
outfile.write('# t, Ta and Te values\n')
for xi, yi, zi in zip(t, Ta, Te):
    outfile.write('%10.5f %10.5f %10.5f\n' % (xi, yi, zi))
outfile.close()